Imports System.IO
Imports System.Data.SqlClient
Imports System.Text

Public Class PDFGeneratorDemo
    Inherits System.Web.UI.Page

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents lblStatus As System.Web.UI.WebControls.Label
    Protected WithEvents cmdReport1 As System.Web.UI.WebControls.Button
    Protected WithEvents cmdReport2 As System.Web.UI.WebControls.Button
    Protected WithEvents cmdReport4 As System.Web.UI.WebControls.Button
    Protected WithEvents cmdReport3A As System.Web.UI.WebControls.Button
    Protected WithEvents cmdReport3B As System.Web.UI.WebControls.Button

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

#Region "Private Members"
    Private RecordCounter As Integer
#End Region

    Private Sub ClearStatus()
        lblStatus.Text = String.Empty
    End Sub

    Public Function GetData(ByVal CommandText As String, ByVal ClassName As String) As ArrayList
        'Dim ConnStr As String = "Server=.\SQLEXPRESS;Initial Catalog=DNN4;uid=DNN4DbUsr;pwd=DNN4;"
        Dim ConnStr As String = System.Configuration.ConfigurationSettings.AppSettings("SiteSqlServer")
        Dim ConnObj As New SqlConnection(ConnStr)
        Dim CmdObj As New SqlCommand

        ConnObj.Open()
        With CmdObj
            .CommandText = CommandText
            .CommandType = CommandType.Text
            .Connection = ConnObj
        End With
        Dim dr As SqlDataReader
        Try
            dr = CmdObj.ExecuteReader(CommandBehavior.CloseConnection)
            Return CBO.FillCollection(dr, Type.GetType(ClassName))

        Catch ex As Exception
            lblStatus.Text = "Data Exception: " & ex.Message
        Finally
            If Not dr Is Nothing AndAlso Not dr.IsClosed Then
                dr.Close()
            End If
        End Try

    End Function


    Private Sub cmdReport1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdReport1.Click
        ClearStatus()
        Try
            Dim Report1 As New WESNet.PDF.PDFGenerator("Report 1.xml")
        Catch ex As Exception
            lblStatus.Text = "ERROR: " & ex.Message
        End Try
    End Sub


    Private Sub cmdReport2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdReport2.Click
        ClearStatus()
        Try
            Dim Report2 As New WESNet.PDF.PDFGenerator("Report 2.xml")
            Dim StateGrid As WESNet.PDF.PDFGrid

            With Report2
                StateGrid = CType(.GetSection("StateGrid"), WESNet.PDF.PDFGrid)
                If StateGrid Is Nothing Then
                    lblStatus.Text = "ERROR: Report section PDFGrid with ID of 'StateGrid' could not be located"
                Else
                    StateGrid.DataSource = GetData("SELECT TOP 15 EntryID, Value, Text FROM dbo.DNN_Lists WHERE ParentID=221;", "StateInfo")
                    .DataBind()
                    .Output()
                End If
            End With
        Catch ex As Exception
            lblStatus.Text = "ERROR: " & ex.Message
        End Try
    End Sub

    Private Sub cmdReport3A_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdReport3A.Click
        ClearStatus()
        Try
            Dim Report3A As New WESNet.PDF.PDFGenerator("Report 3A.xml")
        Catch ex As Exception
            lblStatus.Text = "ERROR: " & ex.Message
        End Try
    End Sub

    Private Sub cmdReport3B_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdReport3B.Click
        ClearStatus()
        Try
            Dim Report3B As New WESNet.PDF.PDFGenerator("Report 3B.xml")
        Catch ex As Exception
            lblStatus.Text = "ERROR: " & ex.Message
        End Try
    End Sub

    Private Sub cmdReport4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdReport4.Click
        ClearStatus()
        Try
            Dim Report4 As New WESNet.PDF.PDFGenerator("Report 4.xml")
            Dim UserGrid As WESNet.PDF.PDFGrid

            With Report4
                UserGrid = CType(.GetSection("UserGrid"), WESNet.PDF.PDFGrid)
                If UserGrid Is Nothing Then
                    lblStatus.Text = "ERROR: Report section PDFGrid with ID of 'UserGrid' could not be located"
                Else
                    AddHandler UserGrid.ItemDataBound, AddressOf UserGrid_OnItemDataBound
                    AddHandler UserGrid.ItemCreated, AddressOf UserGrid_OnItemCreated
                    RecordCounter = 0
                    .DataBind()
                    .Output()
                End If
            End With
        Catch ex As Exception
            lblStatus.Text = "ERROR: " & ex.Message
        End Try
    End Sub

    Protected Sub UserGrid_OnItemDataBound(ByVal s As Object, ByVal e As WESNet.PDF.PDFItemEventArgs)
        If e.Item.ItemType = ListItemType.Item Or e.Item.ItemType = ListItemType.AlternatingItem Then
            Dim ui As DemoUserInfo = CType(e.Item.DataItem, DemoUserInfo)
            e.Item.Cells.Item(0).Text = ui.LastName & ", " & ui.FirstName
            RecordCounter += 1
        End If
    End Sub

    Protected Sub UserGrid_OnItemCreated(ByVal s As Object, ByVal e As WESNet.PDF.PDFItemEventArgs)
        If e.Item.ItemType = ListItemType.Footer Then
            Dim Columns As Integer = e.Item.Cells.Count
            For i As Integer = Columns - 1 To 1 Step -1
                e.Item.Cells.RemoveAt(i)
            Next
            e.Item.Cells.Item(0).ColumnSpan = Columns
            e.Item.Cells.Item(0).Text = "Users Processed: " & RecordCounter.ToString
        End If
    End Sub
End Class
