Imports System.componentModel
Imports System.Globalization

Namespace WESNet
    Public Class BorderConverter
        Inherits TypeConverter

        Public Overloads Overrides Function CanConvertFrom(ByVal context As ITypeDescriptorContext, ByVal sourceType As Type) As Boolean
            If (sourceType Is GetType(String)) Then
                Return True
            End If
            Return MyBase.CanConvertFrom(context, sourceType)
        End Function

        Public Overloads Overrides Function ConvertFrom(ByVal context As ITypeDescriptorContext, ByVal culture As CultureInfo, ByVal value As Object) As Object
            If value Is Nothing Then Return Nothing
            If TypeOf value Is String Then
                Dim text1 As String = CType(value, String).Trim()
                If text1.Length = 0 Then Return Border.Empty
                Return Border.Parse(text1, culture)
            End If
            Return MyBase.ConvertFrom(context, culture, value)

        End Function

        Public Overloads Overrides Function ConvertTo(ByVal context As ITypeDescriptorContext, ByVal culture As CultureInfo, ByVal value As Object, ByVal destinationType As Type) As Object
            If (Not destinationType Is GetType(String)) Then
                Return MyBase.ConvertTo(context, culture, value, destinationType)
            End If
            If (Not value Is Nothing) Then
                Dim Border1 As Border = CType(value, Border)
                If Not Border1.IsEmpty Then
                    Border1 = CType(value, Border)
                    Return Border1.ToString(culture)
                End If
            End If
            Return String.Empty
        End Function
    End Class
End Namespace
