Imports System.ComponentModel

Namespace WESNet.PDF

    'The CellStyle class adds the properties HorizontalAlign, VerticalAlign, and Wrap to
    'the SectionStyle class' properties.

    <TypeConverter(GetType(ExpandableObjectConverter))> _
    Public Class CellStyle
        Inherits SectionStyle

#Region "Private Members"
        Private _HorizontalAlign As System.Web.UI.WebControls.HorizontalAlign
        Private _VerticalAlign As System.Web.UI.WebControls.VerticalAlign
        Private _Wrap As Boolean
#End Region

#Region "Public Properties"

        Public Property VerticalAlign() As System.Web.UI.WebControls.VerticalAlign
            Get
                If IsSet(PROP_VERTALIGN) Then
                    Return _VerticalAlign
                Else
                    Return Web.UI.WebControls.VerticalAlign.NotSet
                End If
            End Get
            Set(ByVal Value As System.Web.UI.WebControls.VerticalAlign)
                If Value < Web.UI.WebControls.VerticalAlign.NotSet Or Value > Web.UI.WebControls.VerticalAlign.Bottom Then
                    Throw New ArgumentOutOfRangeException("Invalid value specified for VerticalAlign")
                Else
                    _VerticalAlign = Value
                    SetBit(PROP_VERTALIGN)
                End If
            End Set
        End Property

        Public Property Wrap() As Boolean
            Get
                If IsSet(PROP_WRAP) Then
                    Return _Wrap
                Else
                    Return True
                End If
            End Get
            Set(ByVal Value As Boolean)
                _Wrap = Value
                SetBit(PROP_WRAP)
            End Set
        End Property
#End Region

#Region "Public Methods"
        Public Overrides Sub CopyFrom(ByVal s As Style)
            If Not s Is Nothing AndAlso Not s.IsEmpty Then
                MyBase.CopyFrom(s)
                If TypeOf (s) Is CellStyle Then
                    Dim s1 As CellStyle = CType(s, CellStyle)
                    With s1
                        If .IsSet(PROP_VERTALIGN) And .VerticalAlign <> Web.UI.WebControls.VerticalAlign.NotSet Then
                            VerticalAlign = .VerticalAlign
                        End If
                        If .IsSet(PROP_WRAP) And Not .Wrap Then
                            Wrap = .Wrap
                        End If
                    End With
                End If
            End If
        End Sub

        Public Overrides Sub MergeWith(ByVal s As Style)
            If Not s Is Nothing AndAlso Not s.IsEmpty Then
                MyBase.MergeWith(s)
                If TypeOf (s) Is CellStyle Then
                    Dim s1 As CellStyle = CType(s, CellStyle)
                    With s1
                        If .IsSet(PROP_VERTALIGN) And ((Not IsSet(PROP_VERTALIGN)) Or VerticalAlign = Web.UI.WebControls.VerticalAlign.NotSet) Then
                            VerticalAlign = .VerticalAlign
                        End If
                        If .IsSet(PROP_WRAP) And ((Not IsSet(PROP_WRAP)) Or Not Wrap) Then
                            Wrap = .Wrap
                        End If
                    End With
                End If
            End If
        End Sub
#End Region

    End Class
End Namespace

