Imports System.Xml

Namespace WESNet.PDF

    'The HeaderFooter class defines a report header or footer section

    Public Class HeaderFooter
        Inherits Label

        Private _Phrase As iTextSharp.text.Phrase
        Private _Template As iTextSharp.text.pdf.PdfTemplate

        Public ReadOnly Property Phrase() As iTextSharp.text.Phrase
            Get
                Return _Phrase
            End Get
        End Property

        Public ReadOnly Property Template() As iTextSharp.text.pdf.PdfTemplate
            Get
                Return _Template
            End Get
        End Property

        Public Sub New(ByVal SectionType As SectionTypes)
            MyBase.New(SectionType)
        End Sub

        Public Sub New(ByVal SectionType As SectionTypes, ByVal Node As XmlNode)
            MyBase.New(SectionType, Node)
        End Sub

        Public Overrides Function RenderedContent(ByVal writer As PDFWriter) As iTextSharp.text.IElement
            _Phrase = CType(MyBase.RenderedContent(writer), iTextSharp.text.Phrase)
            Return _Phrase
        End Function
    End Class

    Public Class Footer
        Inherits HeaderFooter

        Public Sub New()
            MyBase.New(SectionTypes.PageFooter)
        End Sub

        Public Sub New(ByVal Text As String)
            Me.New()
            Me.Text = Text
        End Sub

        Public Sub New(ByVal Node As XmlNode)
            MyBase.New(SectionTypes.PageFooter, Node)
        End Sub

        Public Overrides Function RenderedContent(ByVal writer As PDFWriter) As iTextSharp.text.IElement
            Dim Phrase As iTextSharp.text.Phrase = CType(MyBase.RenderedContent(writer), iTextSharp.text.Phrase)
            Return Phrase
        End Function
    End Class

    Public Class Header
        Inherits HeaderFooter

        Public Sub New()
            MyBase.New(SectionTypes.PageHeader)
        End Sub

        Public Sub New(ByVal Text As String)
            Me.New()
            Me.Text = Text
        End Sub

        Public Sub New(ByVal Node As XmlNode)
            MyBase.New(SectionTypes.PageHeader, Node)
        End Sub

        Public Overrides Function RenderedContent(ByVal writer As PDFWriter) As iTextSharp.text.IElement
            Dim Phrase As iTextSharp.text.Phrase = CType(MyBase.RenderedContent(writer), iTextSharp.text.Phrase)
            Return Phrase
        End Function
    End Class
End Namespace
