Namespace WESNet.PDF

    'Defines an object representing each row of a PDFGrid

    Public Class PDFItem
        Inherits TableRow

#Region "Private Members"
        Private _ItemType As System.Web.UI.WebControls.ListItemType
        Private _ItemIndex As Integer
        Private _DataSetIndex As Integer
        Private _DataItem As Object
#End Region

#Region "Public Properties"
        Public Property DataItem() As Object
            Get
                Return _DataItem
            End Get
            Set(ByVal Value As Object)
                _DataItem = Value
            End Set
        End Property

        Public ReadOnly Property DataSetIndex() As Integer
            Get
                Return _DataSetIndex
            End Get
        End Property

        Public ReadOnly Property ItemIndex() As Integer
            Get
                Return _ItemIndex
            End Get
        End Property

        Public ReadOnly Property ItemType() As System.Web.UI.WebControls.ListItemType
            Get
                Return _ItemType
            End Get
        End Property
#End Region

#Region "Public Methods"
        Public Sub SetItemType(ByVal ItemType As System.Web.UI.WebControls.ListItemType)
            _ItemType = ItemType
        End Sub

        Public Overrides Sub AddToTable(ByVal Table As iTextSharp.text.Table)
            MyBase.AddToTable(Table)
            If ItemType = Web.UI.WebControls.ListItemType.Header Then
                Table.LastHeaderRow = ItemIndex
            End If
        End Sub
#End Region

#Region "Constructors"
        Public Sub New(ByVal ItemIndex As Integer, ByVal DataSetIndex As Integer, ByVal ItemType As System.Web.UI.WebControls.ListItemType)
            _ItemIndex = ItemIndex
            _DataSetIndex = DataSetIndex
            _ItemType = ItemType
        End Sub
#End Region

    End Class
End Namespace
