Namespace WESNet.PDF
    Public Class TableRow

#Region "Private Members"
        Private _Cells As TableCellCollection
        Private _Style As CellStyle

#End Region

#Region "Public Properties"

        Public ReadOnly Property Cells() As TableCellCollection
            Get
                If _Cells Is Nothing Then
                    _Cells = New TableCellCollection(Me)
                End If
                Return _Cells
            End Get
        End Property
        Public Property HorizontalAlign() As System.Web.UI.WebControls.HorizontalAlign
            Get
                If StyleCreated Then
                    Return Style.HorizontalAlign
                Else
                    Return Web.UI.WebControls.HorizontalAlign.NotSet
                End If
            End Get
            Set(ByVal Value As System.Web.UI.WebControls.HorizontalAlign)
                Style.HorizontalAlign = Value
            End Set
        End Property

        Public ReadOnly Property Style() As CellStyle
            Get
                If _Style Is Nothing Then
                    _Style = New CellStyle
                End If
            End Get
        End Property

        Public ReadOnly Property StyleCreated() As Boolean
            Get
                Return Not _Style Is Nothing
            End Get
        End Property

        Public Property VerticalAlign() As System.Web.UI.WebControls.VerticalAlign
            Get
                If StyleCreated Then
                    Return Style.VerticalAlign
                Else
                    Return Web.UI.WebControls.VerticalAlign.NotSet
                End If
            End Get
            Set(ByVal Value As System.Web.UI.WebControls.VerticalAlign)
                Style.VerticalAlign = Value
            End Set
        End Property
#End Region

#Region "Public Methods"
        Public Overridable Sub AddToTable(ByVal Table As iTextSharp.text.Table)
            For Each Cell As TableCell In Cells
                Cell.AddToTable(Table)
            Next
        End Sub
#End Region
    End Class
End Namespace
