Namespace WESNet.PDF
    Public Class TableStyle
        Inherits SectionStyle

#Region "Private Members"
        Private _GridLines As System.Web.UI.WebControls.GridLines
        Private _CellSpacing As Unit
        Private _CellPadding As Unit
#End Region

#Region "Public Properties"

        Public Property CellSpacing() As Unit
            Get
                If IsSet(PROP_CELLSPACING) Then
                    Return _CellSpacing
                Else
                    Return Unit.Empty
                End If
            End Get
            Set(ByVal Value As Unit)
                _CellSpacing = Value
                SetBit(PROP_CELLSPACING)
            End Set
        End Property

        Public Property CellPadding() As Unit
            Get
                If IsSet(PROP_CELLPADDING) Then
                    Return _CellPadding
                Else
                    Return Unit.Empty
                End If
            End Get
            Set(ByVal Value As Unit)
                _CellPadding = Value
                SetBit(PROP_CELLPADDING)
            End Set
        End Property

        Public Property GridLines() As System.Web.UI.WebControls.GridLines
            Get
                If IsSet(PROP_GRIDLINES) Then
                    Return _GridLines
                Else
                    Return System.Web.UI.WebControls.GridLines.None
                End If
            End Get
            Set(ByVal Value As System.Web.UI.WebControls.GridLines)
                If Value < Web.UI.WebControls.GridLines.None Or Value > Web.UI.WebControls.GridLines.Both Then
                    Throw New ArgumentOutOfRangeException("Invalid value specified for GridLines")
                End If
                _GridLines = Value
                SetBit(PROP_GRIDLINES)
            End Set
        End Property
#End Region

#Region "Public Methods"
        Public Overrides Sub CopyFrom(ByVal s As PDF.Style)
            If Not s Is Nothing AndAlso Not s.IsEmpty Then
                MyBase.CopyFrom(s)
                If TypeOf (s) Is PDF.TableStyle Then
                    Dim s1 As TableStyle = CType(s, PDF.TableStyle)
                    With s1
                        If .IsSet(PROP_CELLSPACING) And Not .CellSpacing.IsEmpty Then
                            CellSpacing = .CellSpacing
                        End If
                        If .IsSet(PROP_CELLPADDING) And Not .CellPadding.IsEmpty Then
                            CellPadding = .CellPadding
                        End If
                        If .IsSet(PROP_GRIDLINES) And .GridLines <> Web.UI.WebControls.GridLines.None Then
                            GridLines = .GridLines
                        End If
                    End With
                End If
            End If
        End Sub

        Public Overrides Sub MergeWith(ByVal s As PDF.Style)
            If Not s Is Nothing AndAlso Not s.IsEmpty Then
                If IsEmpty Then
                    CopyFrom(s)
                Else
                    MyBase.MergeWith(s)
                    If TypeOf (s) Is TableStyle Then
                        Dim s1 As PDF.TableStyle = CType(s, PDF.TableStyle)
                        With s1
                            If .IsSet(PROP_CELLSPACING) And ((Not IsSet(PROP_CELLSPACING)) Or CellSpacing.IsEmpty) Then
                                CellSpacing = .CellSpacing
                            End If
                            If .IsSet(PROP_CELLPADDING) And ((Not IsSet(PROP_CELLPADDING)) Or CellPadding.IsEmpty) Then
                                CellPadding = .CellPadding
                            End If
                            If .IsSet(PROP_GRIDLINES) And ((Not IsSet(PROP_GRIDLINES)) Or GridLines = Web.UI.WebControls.GridLines.None) Then
                                GridLines = .GridLines
                            End If
                        End With
                    End If
                End If
            End If
        End Sub
#End Region

    End Class
End Namespace
