Imports System.ComponentModel
Imports System.Globalization

Namespace WESNet
    Public Class UnitConverter
        Inherits TypeConverter

        ' Methods
        Public Overloads Overrides Function CanConvertFrom(ByVal context As ITypeDescriptorContext, ByVal sourceType As Type) As Boolean
            If (sourceType Is GetType(String)) Then
                Return True
            End If
            Return MyBase.CanConvertFrom(context, sourceType)
        End Function

        Public Overloads Overrides Function ConvertFrom(ByVal context As ITypeDescriptorContext, ByVal culture As CultureInfo, ByVal value As Object) As Object
            If (value Is Nothing) Then
                Return Nothing
            End If
            If Not TypeOf value Is String Then
                Return MyBase.ConvertFrom(context, culture, value)
            End If
            Dim text1 As String = CType(value, String).Trim
            If (text1.Length = 0) Then
                Return Unit.Empty
            End If
            If (Not culture Is Nothing) Then
                Return Unit.Parse(text1, culture)
            End If
            Return Unit.Parse(text1)

        End Function

        Public Overloads Overrides Function ConvertTo(ByVal context As ITypeDescriptorContext, ByVal culture As CultureInfo, ByVal value As Object, ByVal destinationType As Type) As Object
            If (Not destinationType Is GetType(String)) Then
                Return MyBase.ConvertTo(context, culture, value, destinationType)
            End If
            If (Not value Is Nothing) Then
                Dim unit1 As Unit = CType(value, Unit)
                If Not unit1.IsEmpty Then
                    unit1 = CType(value, Unit)
                    Return unit1.ToString(culture)
                End If
            End If
            Return String.Empty
        End Function
    End Class
End Namespace

